package install

import (
	"crypto/rand"
	"crypto/rsa"
	"crypto/x509"
	"encoding/pem"
	"fmt"
	"io/ioutil"
	"os"
	"os/exec"
	"strings"

	"github.com/sethvargo/go-password/password"
	log "github.com/sirupsen/logrus"
	"golang.org/x/crypto/ssh"
	"gopkg.in/yaml.v3"

	mrsconfig "gitlab.com/mergetb/facility/mars/pkg/config"
	gcconfig "gitlab.com/mergetb/ops/ground-control/pkg/config"
)

const (
	installDir              = "merge-install"
	generatedConfigFilename = installDir + "/mars-config.yml"
	gitBranch               = "main"
)

type Config struct {
	Gc   *gcconfig.Config  `yaml:"ground-control,omitempty"`
	Mars *mrsconfig.Config `yaml:"mars,omitempty"`
}

func GetConfig(userConfigFilename string) (*Config, error) {
	c := new(Config)

	if userConfigFilename != "" {
		log.Infof("user provided configuration: %s", userConfigFilename)

		if !fileExists(userConfigFilename) {
			return nil, fmt.Errorf("user config file %s does not exist", userConfigFilename)
		}

		err := c.readUserConfig(userConfigFilename)
		if err != nil {
			return nil, err
		}
	} else {
		log.Warnf("No user configuration provided")
	}

	c.applyDefaults()

	err := c.initGeneratedConfig()
	if err != nil {
		return nil, err
	}

	err = c.checkConfig()
	if err != nil {
		return nil, err
	}

	return c, nil
}

func (c *Config) OpsPasswordHash() (string, error) {
	out, err := exec.Command("mkpasswd", c.Mars.Ops.Password).CombinedOutput()
	if err != nil {
		return "", err
	}
	return strings.TrimSuffix(string(out), "\n"), nil
}

func (c *Config) readUserConfig(filename string) error {
	buf, err := ioutil.ReadFile(filename)
	if err != nil {
		return fmt.Errorf("read user config: %v", err)
	}

	err = yaml.Unmarshal(buf, c)
	if err != nil {
		return fmt.Errorf("unmarshal user config: %v", err)
	}

	return nil
}

func (c *Config) applyDefaults() {

	// Gc defaults
	if c.Gc == nil {
		c.Gc = &gcconfig.Config{}
	}

	if c.Gc.Domain == "" {
		c.Gc.Domain = "mars.example.com"
	}

	if c.Gc.Subnet == "" {
		c.Gc.Subnet = "10.0.0.0/16"
	}

	staticFiles := map[string]string{
		"canopy":       "https://gitlab.com/mergetb/facility/mars/-/jobs/artifacts/" + gitBranch + "/raw/build/canopy?job=make",
		"canopy.arm5":  "https://gitlab.com/mergetb/facility/mars/-/jobs/artifacts/" + gitBranch + "/raw/build/canopy.arm5?job=make",
		"mars-install": "https://gitlab.com/mergetb/facility/mars/-/jobs/artifacts/" + gitBranch + "/raw/build/mars-install?job=make",
		// "canopy.arm7"  : "https://gitlab.com/mergetb/facility/mars/-/jobs/artifacts/" + gitBranch + "/raw/build/canopy.arm7?job=make",
	}

	// iterate through provided config, removing duplicates from the list above to allow user override
	for _, sf := range c.Gc.StaticFiles {
		delete(staticFiles, sf.DestFilename)
	}

	// add defaults
	for dst, src := range staticFiles {
		c.Gc.StaticFiles = append(c.Gc.StaticFiles, gcconfig.StaticFile{
			SourceURL:    src,
			DestFilename: dst,
		})
	}

	// wipe out anything else in the config, needs to be autogenerated
	c.Gc.Nodes = nil
	c.Gc.Switches = nil
	c.Gc.Services = nil

	if c.Gc.OnieURL == "" {
		// default from ground-control
		c.Gc.OnieURL = "https://storage.googleapis.com/3p-content-mergetb-dev/cumulus-linux-4.3.0-vx-amd64.bin"
	}

	if c.Mars == nil {
		c.Mars = &mrsconfig.Config{}
	}

	// Mars defaults
	mrsconfig.SetDefaults(c.Mars)
}

func (c *Config) checkConfig() error {
	// TODO
	return nil
}

func (c *Config) initGeneratedConfig() error {
	err := os.MkdirAll(installDir, 0744)
	if err != nil {
		return fmt.Errorf("mkdir merge-config: %v", err)
	}

	mrs := c.Mars

	// init ops account
	ops := &mrs.Ops

	if ops.Username == "" {
		ops.Username = "ops"
	}

	if ops.Password == "" {
		ops.Password, err = password.Generate(32, 10, 0, false, false)
		if err != nil {
			return fmt.Errorf("generate ops password: %v", err)
		}
	}

	if ops.Ssh.Private == "" || ops.Ssh.Public == "" {
		err = initSSHKey(mrs)
		if err != nil {
			return fmt.Errorf("generate ssh key: %v", err)
		}
	}

	// write ssh keys
	err = writeSSHKey(mrs)
	if err != nil {
		return fmt.Errorf("write ssh key: %v", err)
	}

	// init minio credentials
	minio := &mrs.Services.Infraserver.Minio

	if minio.Credentials.Username == "" {
		minio.Credentials.Username = "mars"
	}

	if minio.Credentials.Password == "" {
		minio.Credentials.Password, err = password.Generate(32, 10, 0, false, false)
		if err != nil {
			return fmt.Errorf("generate minio password: %v", err)
		}
	}

	return nil
}

func initSSHKey(mc *mrsconfig.Config) error {
	private, err := rsa.GenerateKey(rand.Reader, 2048)
	if err != nil {
		return fmt.Errorf("generate private key: %v", err)
	}

	buf := pem.EncodeToMemory(&pem.Block{
		Type:  "RSA PRIVATE KEY",
		Bytes: x509.MarshalPKCS1PrivateKey(private),
	})
	mc.Ops.Ssh.Private = string(buf)

	public, err := ssh.NewPublicKey(&private.PublicKey)
	if err != nil {
		return fmt.Errorf("generate public key: %v", err)
	}

	buf = ssh.MarshalAuthorizedKey(public)
	mc.Ops.Ssh.Public = string(buf)

	return nil
}

func writeSSHKey(mc *mrsconfig.Config) error {
	priv := []byte(mc.Ops.Ssh.Private)
	pub := []byte(mc.Ops.Ssh.Public)

	err := ioutil.WriteFile(fmt.Sprintf("%s/ops_rsa", installDir), priv, 0600)
	if err != nil {
		return fmt.Errorf("write private key: %v", err)
	}

	err = ioutil.WriteFile(fmt.Sprintf("%s/ops_rsa.pub", installDir), pub, 0644)
	if err != nil {
		return fmt.Errorf("write public key: %v", err)
	}

	return nil
}

func fileExists(path string) bool {
	info, err := os.Stat(path)
	if os.IsNotExist(err) {
		return false
	}
	return !info.IsDir()
}
